#!/usr/bin/env python
# -*- coding:utf-8 -*-

# ##############################################################################
#     Base code from where the autogenerated code inherits
#
#     Copyright (C) 2021 Alba Synchrotron/CELLS, Cerdanyola Spain
#
#     This program is free software: you can redistribute it and/or modify
#     it under the terms of the GNU General Public License as published by
#     the Free Software Foundation, either version 3 of the License, or
#     (at your option) any later version.
#
#     This program is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#     GNU General Public License for more details.
#
#     You should have received a copy of the GNU General Public License
#     along with this program.  If not, see [http://www.gnu.org/licenses/].
# ##############################################################################

from datetime import datetime


class CardReader:
    """
This class does the job of read the registers of a card to then store the
information in the internal structures of the device representing each of the
register-attributes, and report which ones have changed (so then the device
can emit tango events for them.
    """
    __card = None

    def __init__(self, card_obj):
        self.__card = card_obj

    def read(self, address_list):
        """
Given a list of register numbers, read all of them one by one sequentially
using the read multiple registers available in the lower level layer.

The idea on that is to have all those reads as close as possible in time.

:param address_list: list of register addresses
:return: dictionary with the results and the time used to perform the action
        """
        results = {}
        t_0 = datetime.now()
        # for address in address_list:
        #     results[address] = self.__card.read_register(address)
        values = self.__card.read_registers(*address_list)
        results = dict(zip(address_list, values))
        t_delta = datetime.now()-t_0
        return results, t_delta
